// Моя версия скетча для поворотной платформы

#include "defines.h"
// библиотека IR
#include <IRremote.h> 
//вход ИК приемника
int RECV_PIN = 2;  
IRrecv irrecv(RECV_PIN);
IRsend irsend;
decode_results results; 
unsigned long ir_dt, old_ir;
long ir_kod;
unsigned long ir_time1, ir_time2;
// клавиатура
#include <Keypad.h>
const byte ROWS = 3; //four rows
const byte COLS = 3; //four columns
char keys[ROWS][COLS] = {
    {'4','5','6'},{'7','8','9'},{'*','0','#'}};

byte rowPins[ROWS] = {14,15,16}; //connect to the row pinouts of the keypad
byte colPins[COLS] = {17,18,19}; //connect to the column pinouts of the keypad

Keypad keypad = Keypad( makeKeymap(keys), rowPins, colPins, ROWS, COLS );
char key=' ';

//////////    Stepper
#include <AccelStepper.h>
AccelStepper stepper1(2,9,10); 

//
#include <LiquidCrystal.h>
LiquidCrystal lcd(12,11,7,6,5,4);
//
#include <EEPROM.h>
// состояние дисплея
struct VIEW    
{
  int count_prg;   // кол-во программ
  int tek_prg;         // текущая программа
  int pos_prg;      // позиция в программе
  int val[10];      // значение позиции
  
};
VIEW VIEW1={0,0,0,{0,0,0,0,0,0,0,0,0,0}};
// шаговый двигатель
struct RUN    // структура 
{
  int tekrunprg;
  long steps;      // 
  long step;      // 
  int countstep;
  int speed;   // 
  int circles;
  int tekcircle;  
  int dtekcircle;  
  int direction;
  int tekdirection;
  int photo;
  int stopphoto;
  int photopause;
  int pause;
  int statuspause;
  unsigned long millispause;
};
RUN RUN1={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
// min,max,step для настроек
unsigned long minvalue[9]={0,0,0,0,0,0,0,0,0};
unsigned long maxvalue[9]={370,370,3100,4,100,2,2,100,9000};
unsigned long stepvalue[9]={5,5,50,1,1,1,1,1,500};
int mode;
unsigned long milliskey=0;
unsigned long milliscalib=0;
long pos1=0;
long pos2=0;
int K1=100;

void setup()
  {
  // последовательный порт 
  Serial.begin(9600); 
  // дисплей
  lcd.begin(16,2);
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("photopizza v0.06");
  lcd.setCursor(0,1);
  lcd.print("+79034461752");
  // инициализация настроек из EEPROM 
  if(EEPROM.read(0)==255)
     {
     clear_eeprom();
     ini_eeprom(1);
     }
  // инициализация настроек из EEPROM 
  get_param_prg_eeprom(0);
  //
  delay(2000);
  mode = VIEW_MODE;
  lcd_str1(mode);
  lcd_str2ve();  
  //
  stepper1.setSpeed(500);
  //stepper1.setAcceleration(100.0);
  // включить приемник 
  irrecv.enableIRIn(); 
  // прерывания для ИК
  ir_time1=0;ir_time2=0;
  attachInterrupt(0, get_ir_kod, FALLING); 
  }
void loop()
  {
  // обработка кода нажатия
  if(ir_kod>0)
   {
   Serial.print("ir_kod=");Serial.println(ir_kod,HEX);
   lcd_get_key(2);milliskey=millis();
   key=ir_to_key(ir_kod); 
   ir_kod=0;
   do_for_key(mode,key);   
   } 
  key = keypad.getKey();
  if(key){
    Serial.print("key=");Serial.println((int)key); 
    lcd_get_key(1);milliskey=millis();
    do_for_key(mode,key);   
    } 
  //
  if(millis()-milliskey>1000) 
    lcd_get_key(0);
  if(mode==CALIB_MODE)
    {
    stepper1.runSpeed();
    if(millis()-milliscalib>1000) 
       {lcd_str2calib(stepper1.currentPosition());
       milliscalib=millis();
       Serial.println(stepper1.currentPosition());
       }
    }
  if (stepper1.distanceToGo() == 0 && RUN1.tekrunprg>0)
    {
    RUN1.countstep=RUN1.countstep+1; 
    if(RUN1.steps>RUN1.step*RUN1.countstep) // 1 цикл несколько шагов
       {
       Serial.print("current=");Serial.println(stepper1.currentPosition());
       Serial.print("countstep=");Serial.println(RUN1.countstep);
       if(mode==RUN_MODE)
         lcd_str2run();
       if(RUN1.stopphoto>0)
         delay(RUN1.pause);
       pos1=min(RUN1.steps,RUN1.step*(RUN1.countstep+1));
       pos2=pos1*K1*kdirs[RUN1.tekdirection];
       Serial.print("pos1=");Serial.println(pos1);
       Serial.print("pos2=");Serial.println(pos2);
       stepper1.moveTo(pos2);
       }
    else  // закончился круг
      {
      Serial.print("current=");Serial.println(stepper1.currentPosition());
      Serial.print("countstep=");Serial.println(RUN1.countstep);
      if(mode==RUN_MODE)
         lcd_str2run();
      RUN1.tekcircle=RUN1.tekcircle+RUN1.dtekcircle;
      if(RUN1.circles>RUN1.tekcircle || RUN1.circles==0) 
         {
         stepper1.setCurrentPosition(0);
         RUN1.countstep=0;
         stepper1.setSpeed(0);
         stepper1.setCurrentPosition(0);
         if(RUN1.stopphoto>0)
           {
           if(RUN1.photo>0)
             {
             detachInterrupt(0); 
             delay(100);
             for (int i = 0; i < 5; i++) 
                {irsend.sendSony(0x8CBC0,20);delay(100);} 
             delay(RUN1.pause);
             attachInterrupt(0, get_ir_kod, FALLING);
             irrecv.enableIRIn(); 
               
             }
           else
             delay(RUN1.pause);
           }
         if(RUN1.tekdirection>1)
           RUN1.tekdirection=RUN1.tekdirection+kdirs[RUN1.tekdirection]; 
      Serial.print("current=");Serial.println(stepper1.currentPosition());
      Serial.print("countstep=");Serial.println(RUN1.countstep);
      if(mode==RUN_MODE)
         lcd_str2run();
         stepper1.setSpeed(RUN1.speed*kdirs[RUN1.tekdirection]);
         stepper1.moveTo(min(RUN1.steps,RUN1.step)*K1*kdirs[RUN1.tekdirection]); 
         }
      else
         {
         stepper1.setSpeed(0);
         stepper1.setCurrentPosition(0);
         mode=VIEW_MODE;RUN1.tekrunprg=0;
         lcd_str1(mode);lcd_str2ve();
         }
      Serial.print("currentPos=");Serial.println(stepper1.currentPosition());
      }
    }
  else if(RUN1.tekrunprg>0)
    stepper1.runSpeed();
  else
    ;
  }

